.SUFFIXES: .asm

# defines
MAKEFILE=Makefile
MAKEDEP=$(MAKEFILE)
INCDIR	=../include
NASM	=nasm -f elf -i$(INCDIR)/
CFLAGS  =-g -Wall -W -O2 -nostdinc -fno-builtin -fno-stack-protector -Wno-unused-parameter -I$(INCDIR) -I../build/main
CCASM	=$(CC) -D__ASSEMBLY__ -g -Os -pipe -mcpu=arm926ej-s -mabi=apcs-gnu -fno-strict-aliasing  -fno-common -ffixed-r8 -msoft-float -fno-builtin -ffreestanding -nostdinc
STDIO	=stdio/doprintf.o stdio/delay.o stdio/kprintf.o stdio/printf.o stdio/sprintf.o stdio/open.o stdio/close.o stdio/write.o stdio/read.o
STDLIB	=stdlib/atoi.o stdlib/abort.o stdlib/strtol.o
STRING	=string/memsetw.o string/memcpy.o string/strlen.o string/strcpy.o string/strcat.o string/memset.o string/strcmp.o
ARCHDEP	=x86/dma.o x86/setjmp.o x86/longjmp.o
CTYPE	=ctype/ctype.o
UNISTD  =unistd/fcntl.o unistd/lseek.o unistd/pipe.o
SYS	=sys/select.o

ifeq ($(ARCH),arm)
       CFLAGS=-g -Os -fno-builtin -ffreestanding -nostdinc -pipe -mcpu=arm926ej-s -mabi=apcs-gnu -nostdlib -nostartfiles -nodefaultlibs  -ffixed-r8 -msoft-float -I$(INCDIR) -I../build/main
       ARCHDEP=arm/divsi3.o arm/div0.o arm/modsi3.o
endif

OBJS	=$(STDIO) $(STDLIB) $(STRING) $(ARCHDEP) $(CTYPE) $(UNISTD) $(SYS) $(ARCHDEP)

ifneq ($(V),1)
	Q := @
endif

# targets
all: $(OBJS) libc.a

clean:
	$(Q)rm -f libc.a $(OBJS)
	@printf "  CLEAN\n";

# implicit rules
.s.o:
	@printf " ASM  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(NASM) -o$@ $<

.S.o:
	@printf " ASM  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(CCASM) -c -o$@ $<

.c.o:
	@printf "  CC  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(CC) $(CFLAGS) -c -o$@ $<

# explicit rules
libc.a:	$(OBJS) $(MAKEDEP)
	@printf "  AR  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(AR) rcs libc.a $(OBJS)
